## phosh-0.15.0.tar.xz

=== meson_options.txt ===
option('tests',
       type: 'boolean', value: true,
       description: 'Whether to compile unit tests')

option('phoc_tests',
       type: 'feature', value: 'auto',
       description: 'Whether to enable tests that need phoc')

option('gtk_doc',
       type: 'boolean', value: false,
       description: 'Whether to generate the API reference for Phosh')

option('systemd',
       type: 'boolean', value: false,
       description: 'Whether to generate systemd user units')

option('compositor',
       type: 'string', value: '/usr/bin/phoc',
       description: 'Path to the Phoc compositor for use in the launcher script')

option('callui-i18n',
       type: 'boolean', value: false,
       description: 'Whether to install libcallui\s i18n fles')

option('osk-stub',
       type: 'boolean', value: false,
       description: 'Whether to build and install the osk stub')

# Tools helping with e.g. notification server development
option('tools',
       type: 'boolean', value: false,
       description: 'Whether to build the tools')

=== debian/changelog ===
phosh (0.15.0) experimental; urgency=medium

  [ Guido Günther ]
  * wifimanager: Create NetworkAgent async.
    This avoids a `g_main_loop_run` in the sync init.
  * monitor: Fix indentation
  * doc-check: Allow to specify dir to check
  * doc-check: Avoid whitespace that breaks the check
  * wl-buffer: Move create_shm_file to utils.
    This can be used in multiple places
  * monitor-manager: Use phosh_create_shm_file.
    This fixes a missing error check for the returned fd as well.
  * toplevel-thumbnail: Use phosh_shm_file ()
  * run-command-manager: Fix section name and log domain.
    Drop the additional "dialog-" which is not part or the class name.
  * media-player: Only load file URIs.
    Data from the network needs to be fetched async since it
    can stall. (Closes: #583)
  * testlib: Ignore warnings and criticals from the compositor.
    (avoids test failures with older phoc)
  * gitlab-ci: No need to forcibly remove lcov anymore.
    Debian's gcovr doesn't depend on lcov anymore
    (https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=987818)
  * gitlab-ci: Use newer docker image.
    This doesn't forcibly remove lcov anymore which makes e.g. adding
    packages easier.
  * system-prompt: Handle mnemonic in choice label.
    Some of the prompt use it (e.g. gpg prompts for "save in password
    manager"). Otherwise we'd just get a leading '_'.
    Fixes: de1b395e ("system-prompt: Make sure the choice label wraps")
  * system-prompt: Use consistent spacing.  We use 6px between label and
    button.
  * toplevel-thumnail: Drop flag check
    phoc <= 0.10.0 sent y_invert although we didn't use it. Phoc
    >= 11.0 doesn't send it triggering the critical so drop it.
  * run: Drop gnome session setup.
    Most of the time people want phosh+phoc so the session just causes
    trouble. We can drop it and people can needing a session can just fire
    it up. Adjust the README accordingly.
  * run: Always start unlocked.
    Running nested is the main use case and one usually wants an
    unlocked shell there so run unlocked by default.
    If people want to run locked they can pass '-L'.
    Adjust docs accordingly
  * README: Drop install step.  One can run fine out of the source tree and
    this avoids spreading files all over /usr/local.
  * README: Make phoc config the first argument.
    Makes it easier to edit phosh's run options
  * README: Use a screenshot of the unlocked shell.
    Since this is what we're launching in the example above.
  * run: Make it simple to override debugging.
    While full debugging is often useful sometimes one wants to limit to
    certain modules so honor a set `G_MESSAGES_DEBUG`.
  * README: Use ```sh for shell snippets.
    Be consistent. Also drop leading whitespace to ease copy/paste.
  * README: Fix path to gitlab-ci file
  * README: Drop section on libhandy.  It can be used as a subproject
  * run-command-dialog: Split submitted and cancelled signal.
    This will simplify processing when we handle errors better.
  * run-command-manager: Fix indentation
  * run-command-manager: Return success/failure when running command.
    Swap success/failure case while at that to avoid a negated expression.
  * run-command-dialog: Drop unneeded can-focus properties
  * run-command-{dialog,manager}: Show error message when command failed
  * run-command-dialog: Use on_ prefix consistently.  We allow for both
    (prefering `on_`) but don't want to mix in the same class.
  * background: Allow absolute paths too.
    When e.g. gnome-photos sets a background it uses an absolute path.
  * util: Add helper to markup escape text.
    This either escapes all markup or preserves elements allowed
    via the notification spec in a notification body. Based on
    what gnome-shell does as of commit
    919c4cf3d5657dd93f0c14c21a30071b8e90f6e2. Bugs introduced are
    my own.
  * notify-manager: Escape notification bodies.
    Otherwise bodies with markup would silently be dropped.
    Closes: https://gitlab.gnome.org/World/Phosh/phosh/-/issues/690
  * system-modal-dialog: Mark swipe-away-bin as vertical
  * stylesheet: Sort colors alphabetically.
    Makes things easier when we add more
  * gitla-ci.yml: Don't build tests when building the docs.
    This brings down compilation time and resource usage and
    the tests don't contribute to the docs atm.
  * system-prompt: Don't access priv before checking the type
  * tests: Name screenshot suite as such.
    The tests aren't manual anyway since they're run by default.
  * Move network-auth related bits out of wifi-manager.
    Other connections types such as VPN want to do auth too
  * network-auth-prompt: Remove unused nmclient
  * network-auth-prompt: Drop custom Esc-key handler.
    Rather only use the one from system-auth-prompt since that is also
    wired up to properly cancel the network-auth request via
    `on_dialog_canceled()`.
    Otherwise e.g. VPN auth prompts can hang up to timeout
  * network-auth-manager: Use cancellable for agent registration too.
    We want to cancel this in case of e.g. early shutdown.
  * network-auth-manger: Use a separate cancellable for registration.
    NM doesn't like if we cancel a successful operation later on rather
    crahes in NMSecrentAgentOld's _register_cancelled_cb since the task data
    is already freed.
    Closes: https://gitlab.gnome.org/World/Phosh/phosh/-/issues/673
  * newtork-auth-manager: Drop unused nmclient.
    Now that network-auth-prompt dropped it we can drop it here too after
    fixing cancellation.
  * contrib: Add vpn plugin related bits.
    Bring over the VPN plugin related bits as from gnome-shell's
    shell-network-agent as of 919c4cf3d5657dd93f0c14c21a30071b8e90f6e2.
  * network-auth-{manager,prompt}: Support VPN authentication.
    Heavily inspired by what NetworkManager's secret handling. Errors
    introduced are my own.
    Closes: https://gitlab.gnome.org/World/Phosh/phosh/-/issues/630


=== debian/control ===
Source: phosh
Section: x11
Priority: optional
Maintainer: Guido Günther <agx@sigxcpu.org>
Build-Depends:
 debhelper-compat (= 13),
 gtk-doc-tools <!nodoc>,
 libcallaudio-dev,
 libsecret-1-dev,
 libsystemd-dev,
 libfeedback-dev,
 libgcr-3-dev,
 libglib2.0-doc <!nodoc>,
 libgnome-desktop-3-dev,
 libgtk-3-dev,
 libgtk-3-doc <!nodoc>,
 libgudev-1.0-dev,
 libhandy-1-dev (>= 1.1.90),
 libnm-dev,
 libpam0g-dev,
 libpolkit-agent-1-dev,
 libpulse-dev,
 libupower-glib-dev,
 libwayland-dev,
 linux-libc-dev (>= 5.12) [arm64],
 meson,
 pandoc <!nodoc>,
# to run the tests
 at-spi2-core <!nocheck>,
 dbus-x11 <!nocheck>,
 gnome-settings-daemon-common <!nocheck>,
 gnome-shell-common <!nocheck>,
 gnome-themes-extra-data <!nocheck>,
 gsettings-desktop-schemas <!nocheck>,
 phoc <!nocheck>,
 xvfb <!nocheck>,
 xauth <!nocheck>,
Standards-Version: 4.1.3
Homepage: https://gitlab.gnome.org/World/Phosh/phosh/
Rules-Requires-Root: no

Package: phosh
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 fonts-lato,
 gnome-shell-common,
 gsettings-desktop-schemas,
 phoc (>= 0.9.0),
Recommends:
 feedbackd,
 fonts-cantarell,
 gnome-session-bin,
 gnome-session-common,
 gnome-settings-daemon,
 iio-sensor-proxy,
 librsvg2-common,
 phosh-mobile-tweaks,
 squeekboard | phosh-osk-stub,
Provides:
 notification-daemon,
 polkit-1-auth-agent,
Breaks:
 gnome-calls (<< 41~alpha),
Description: Pure Wayland shell for mobile devices
 Phosh is a graphical shell for Wayland compositors speaking the layer-surface
 protocol and aimed at mobile devices like smart phones and tablets using touch
 based inputs and small screens.
 .
 It's part of the Phosh Mobile Environment based on GNOME/GTK. For the full
 stack see the phosh-full and phosh-core metapackages.

Package: phosh-osk-stub
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Conflicts:
 librem5-base
Description: OSK stub to fulfill session dependencies
 Phosh's session wants a sm.puri.OSK0. For testing on non-phone's
 this stub fulfills the necessary dependencies.

Package: phosh-doc
Architecture: all
Section: doc
Build-Profiles: <!nodoc>
Depends:
 ${misc:Depends},
Description: Pure Wayland shell for mobile devices - development documentation
 Phosh is a graphical shell for Wayland compositors speaking the layer-surface
 protocol and aimed at mobile devices like smart phones and tablets using touch
 based inputs and small screens.
 .
 This package contains the development documentation.

Package: phosh-mobile-tweaks
Architecture: all
Depends:
 ${misc:Depends},
 dconf-gsettings-backend | gsettings-backend,
Description: Pure Wayland shell for mobile devices - GSettings tweaks
 Phosh is a graphical shell for Wayland compositors speaking the layer-surface
 protocol and aimed at mobile devices like smart phones and tablets using touch
 based inputs and small screens.
 .
 This package contains settings to improve behaviour on mobile devices.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

CONFIGURE_OPTS=-Dphoc_tests=disabled -Dsystemd=true -Dosk-stub=true

ifeq ($(filter nodoc,$(DEB_BUILD_PROFILES)),)
  CONFIGURE_OPTS+=-Dgtk_doc=true
else
  CONFIGURE_OPTS+=-Dgtk_doc=false
endif

ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
  CONFIGURE_OPTS+=-Dtests=true
else
  CONFIGURE_OPTS+=-Dtests=false
endif

%:
	dh $@ --builddirectory=_build

override_dh_auto_configure:
	dh_auto_configure -- $(CONFIGURE_OPTS)

override_dh_auto_build:
	dh_auto_build
ifeq ($(filter nodoc,$(DEB_BUILD_PROFILES)),)
	# https://github.com/mesonbuild/meson/pull/2862
	ninja -C _build/ phosh-doc
endif

override_dh_installsystemd:
	rm -f debian/phosh.service
	cp data/phosh.service debian/phosh.service
	dh_installsystemd --no-start --no-enable --no-restart-on-upgrade --no-restart-after-upgrade

override_dh_auto_test:
ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	LC_ALL=C.UTF-8 xvfb-run -a meson test -C _build --no-suite manual
endif
